%option prefix="battinfo"
%option noyywrap
%option nounput


%{
#include "acpiintf.h"
#include "valueparsers.h"

static BattInfo *cur_bat_info;  /* battery struct 
                                   we're parsing into right now */

%}

%x PRESENT LASTFULL
%%
^"present:"[[:space:]]+	{ BEGIN(PRESENT);}
<PRESENT>"yes"|"no"	{ parse_boolean(yytext, 
	    &(cur_bat_info->present));
	  BEGIN(0);
	}
^"last full capacity:"[[:space:]]+	{ BEGIN(LASTFULL);}
<LASTFULL>[[:digit:]]+	{ parse_int(yytext,
	    &(cur_bat_info->fullcap));
	  BEGIN(0);
	}
.
"\n"
%%

int parse_battinfo(char *srcfile, BattInfo *bat_info)
{
  if (!(battinfoin = fopen(srcfile, "r"))) {
    return 1;
  }
  cur_bat_info = bat_info;
  battinfolex();
  fclose(battinfoin);
  return 0;
}

/* vi:ts=40:
*/
