%option prefix="battstate"
%option noyywrap
%option nounput

%{
#include "acpiintf.h"
#include "valueparsers.h"

static BattInfo *cur_batt_info;  /* battery struct 
                                   we're parsing into right now */

%}

%x PRESENT REMAINING CHARGESTATE PRESRATE
%%
^"present:"[[:space:]]+	{ BEGIN(PRESENT);}
<PRESENT>"yes"|"no"	{ parse_boolean(yytext, 
	    &(cur_batt_info->present));
	  BEGIN(0);
	}

^"remaining capacity:"[[:space:]]+	{ BEGIN(REMAINING);}
<REMAINING>[[:digit:]]+	{ parse_int(yytext,
	    &(cur_batt_info->currcap));
	  BEGIN(0);
	}

^"present rate:"[[:space:]]+	{ BEGIN(PRESRATE);}
<PRESRATE>[[:digit:]]+	{ parse_int(yytext,
	    &(cur_batt_info->currrate));
	  BEGIN(0);
	}


^"charging state:"[[:space:]]+	{ BEGIN(CHARGESTATE);}
<CHARGESTATE>[[:alpha:]]+	{ cur_batt_info->charge = -1;
	  if (!strcmp(yytext, "charging")) {
	    cur_batt_info->charge = 0;
	  }
	  if (!strcmp(yytext, "discharging")) {
	    cur_batt_info->charge = 1;
	  }
	  if (!strcmp(yytext, "charged")) {
	    cur_batt_info->charge = 2;
	  }
	  BEGIN(0);
	}

.
"\n"
%%

int parse_battstate(char *srcfile, BattInfo *batt_info)
{
  if (!(battstatein = fopen(srcfile, "r"))) {
    return 1;
  }
  cur_batt_info = batt_info;
  battstatelex();
  fclose(battstatein);
  return 0;
}

/* vi:ts=40:
*/
